'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styleMerge = require('style-merge');

var _styleMerge2 = _interopRequireDefault(_styleMerge);

require('./icon.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Author: eason
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Date:   2016-09-26T17:32:15+08:00
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Last modified by:   eason
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Last modified time: 2016-11-28T14:04:40+08:00
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var defaultStyle = {};

var Icon = function (_Component) {
  _inherits(Icon, _Component);

  function Icon() {
    _classCallCheck(this, Icon);

    return _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).apply(this, arguments));
  }

  _createClass(Icon, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          name = _props.name,
          style = _props.style,
          size = _props.size,
          bold = _props.bold,
          color = _props.color,
          others = _objectWithoutProperties(_props, ['name', 'style', 'size', 'bold', 'color']);

      var stl = (0, _styleMerge2.default)(defaultStyle, {
        fontSize: size,
        fontWeight: bold,
        color: color
      }, style);
      var cls = (0, _classnames2.default)((_classNames = {
        'veui-icon': true
      }, _defineProperty(_classNames, 'icon-' + name, true), _defineProperty(_classNames, 'veui_icon_' + name, true), _defineProperty(_classNames, 'material_ui_icon_' + name, true), _classNames));

      return _react2.default.createElement('i', { style: stl, className: cls });
    }
  }]);

  return Icon;
}(_react.Component);

Icon.propTypes = {
  name: _react.PropTypes.string.isRequired
};
exports.default = Icon;