/*
* @Author: fengbo
* @Date:   2017-04-25 11:13:40
* @Last Modified by:   fengbo
* @Last Modified time: 2017-05-04 09:13:30
*/

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Popover = require('material-ui/Popover/Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _FontIcon = require('material-ui/FontIcon');

var _FontIcon2 = _interopRequireDefault(_FontIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props, context, state) {
  var _context$muiTheme = context.muiTheme,
      baseTheme = _context$muiTheme.baseTheme,
      tooltip = _context$muiTheme.tooltip,
      borderRadius = _context$muiTheme.borderRadius;

  var borderWidth = '0 7px 7px 7px';
  var borderColor = 'transparent transparent #717171 transparent';
  var styles = {
    label: {
      color: tooltip.color,
      borderRadius: borderRadius,
      backgroundColor: tooltip.rippleBackgroundColor,
      padding: '0px 5px'
    },
    triangle: {
      position: 'absolute',
      width: 0,
      height: 0,
      left: '42%',
      top: '-7px',
      borderStyle: 'solid',
      borderWidth: '0 7px 7px 7px',
      borderColor: 'transparent transparent #717171 transparent'
    }
  };
  return styles;
}

var PopToolTips = function (_React$Component) {
  _inherits(PopToolTips, _React$Component);

  function PopToolTips(props) {
    _classCallCheck(this, PopToolTips);

    return _possibleConstructorReturn(this, (PopToolTips.__proto__ || Object.getPrototypeOf(PopToolTips)).call(this, props));
  }

  _createClass(PopToolTips, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          show = _props.show,
          anchorEl = _props.anchorEl,
          onRequestClose = _props.onRequestClose;
      var prepareStyles = this.context.muiTheme.prepareStyles;

      var styles = getStyles(this.props, this.context, this.state);
      return _react2.default.createElement(
        _Popover2.default,
        {
          open: show,
          anchorEl: anchorEl,
          useLayerForClickAway: false,
          anchorOrigin: { horizontal: 'middle', vertical: 'bottom' },
          targetOrigin: { horizontal: 'middle', vertical: 'top' }
        },
        _react2.default.createElement(
          'div',
          { style: prepareStyles(styles.label) },
          _react2.default.createElement('span', { style: styles.triangle }),
          label
        ),
        _react2.default.createElement(
          _FontIcon2.default,
          { className: 'material-icons' },
          'ic_arrow_drop_up'
        )
      );
    }
  }]);

  return PopToolTips;
}(_react2.default.Component);

PopToolTips.propTypes = {
  name: _react2.default.PropTypes.string
};
PopToolTips.contextTypes = {
  muiTheme: _react2.default.PropTypes.object.isRequired
};
exports.default = PopToolTips;