'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Slider = require('./Slider');

var _Slider2 = _interopRequireDefault(_Slider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropTimer = function (_Component) {
  _inherits(DropTimer, _Component);

  _createClass(DropTimer, [{
    key: 'handlerOnMOuseMove',
    value: function handlerOnMOuseMove(e) {
      console.log(e);
    }
  }]);

  function DropTimer(props) {
    _classCallCheck(this, DropTimer);

    var _this = _possibleConstructorReturn(this, (DropTimer.__proto__ || Object.getPrototypeOf(DropTimer)).call(this, props));

    _this.handleFirstSlider = function (event, value) {
      // if (value % 10 === value) {
      //   value = "0" + value;
      // }
      _this.setState({ firstSlider: value });
    };

    _this.handleSecondSlider = function (event, value) {
      // if (value % 10 === value) {
      //   value = "0" + value;
      // }
      _this.setState({ secondSlider: value });
    };

    var nowDate = new Date();
    var nowHours = nowDate.getHours();
    var nowMinutes = nowDate.getMinutes();
    _this.state = {
      firstSlider: nowHours,
      secondSlider: nowMinutes
    };
    return _this;
  }

  _createClass(DropTimer, [{
    key: 'getSelectTime',
    value: function getSelectTime() {
      // if(this.state.firstSlider.toString().length<2) this.setState({firstSlider:`0${this.state.firstSlider}`});
      // if(this.state.secondSlider.toString().length<2) this.setState({secondSlider:`0${this.state.secondSlider}`});
      return this.state.firstSlider + ':' + this.state.secondSlider;
    }
  }, {
    key: 'setTime',
    value: function setTime(firstSlider, secondSlider) {
      this.setState({
        firstSlider: firstSlider,
        secondSlider: secondSlider
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var styles = {
        hour_label: {
          float: 'left',
          height: '16px',
          lineHeight: '18px',
          paddingLeft: '1em'
        },
        minute_label: {
          float: 'left',
          height: '16px',
          lineHeight: '18px',
          paddingLeft: '1em'
        },
        hour: {
          display: 'inline-block'
        },
        minute: {
          display: 'inline-block'
        },
        drag_box: {
          width: '240px',
          float: 'left'
          // height: '22px',
          // position: 'relative'
        },
        drag: {
          width: '18px',
          height: '24px',
          position: 'absolute',
          left: 0,
          cursor: 'pointer',
          top: '-3px',
          textAlign: 'center',
          background: '#c2e4ff',
          lineHeight: '24px',
          border: '#42b1ff 1px solid',
          zIndex: 20
        },
        drag_box_bg: {
          background: '#f9f9f9',
          position: 'absolute',
          zIndex: '10',
          left: 0,
          top: '2px',
          width: '100%',
          height: '14px',
          border: 'solid 1px #d0d0d0'
        }
      };
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: styles.hour_label },
          '\u5C0F\u65F6\uFF1A'
        ),
        _react2.default.createElement(_Slider2.default, {
          style: styles.drag_box,
          min: 0,
          max: 23,
          defaultValue: 0,
          value: this.state.firstSlider,
          step: 1,
          onChange: this.handleFirstSlider
        }),
        _react2.default.createElement(
          'div',
          { style: styles.hour_label },
          '\u5206\u949F\uFF1A'
        ),
        _react2.default.createElement(_Slider2.default, {
          style: styles.drag_box,
          sliderValueStyle: { margin: '15px 0px 0px 0px' },
          min: 0,
          max: 59,
          defaultValue: 0,
          value: this.state.secondSlider,
          step: 1,
          onChange: this.handleSecondSlider
        })
      );
    }
  }]);

  return DropTimer;
}(_react.Component);

exports.default = DropTimer;