/*
 * @Author: phobal
 * @Date:   2016-12-09 18:35:36
 * @Last Modified by:   fengbo
 * @Last Modified time: 2017-07-18 10:20:20
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.getStyels = getStyels;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RaisedButton = require('material-ui/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _Chip = require('material-ui/Chip');

var _Chip2 = _interopRequireDefault(_Chip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyels(props, context) {
  return {
    wrapper: {
      display: 'flex',
      flexWrap: 'wrap',
      justifyContent: 'center'
    },
    chip: {
      margin: 10,
      minWidth: 75
    },
    buttonStyle: Object.assign({}, {
      borderRadius: '20px',
      background: '#e7e2e2'
    }, props.buttonStyle)
  };
}
// const buttomGroup = ['近30分', '近1小时', '近6小时', '近1天', '近3天', '近7天']
var buttomGroup = ['近1天', '近3天', '近7天', '近半个月', '近1个月', '近2个月'];

var RecentTime = function (_React$Component) {
  _inherits(RecentTime, _React$Component);

  function RecentTime(props) {
    _classCallCheck(this, RecentTime);

    return _possibleConstructorReturn(this, (RecentTime.__proto__ || Object.getPrototypeOf(RecentTime)).call(this, props));
  }

  _createClass(RecentTime, [{
    key: 'render',
    value: function render() {
      var onClick = this.props.onClick;

      var styles = getStyels(this.props, this.context);
      var buttonlist = buttomGroup.map(function (item, key) {
        return _react2.default.createElement(
          _Chip2.default,
          {
            style: styles.chip,
            key: key,
            onTouchTap: onClick
          },
          item
        );
      });
      return _react2.default.createElement(
        'div',
        { style: styles.wrapper },
        buttonlist
      );
    }
  }]);

  return RecentTime;
}(_react2.default.Component);

RecentTime.propTypes = {
  name: _react2.default.PropTypes.string
};
RecentTime.contextTypes = {
  muiTheme: _react2.default.PropTypes.object.isRequired
};
exports.default = RecentTime;